<?php

class EstadosCivisController extends Controller
{
    private $estadoCivilModel;

    public function __construct()
    {
        if (!Sessao::estaLogado()) {
            URL::redirecionar('usuarios/login');
        }
        $this->estadoCivilModel = $this->model('EstadoCivil');
    }

    public function index()
    {
        $dados = [
            'estados_civis' => $this->estadoCivilModel->lerEstadosCivis()
        ];
        $this->view('layout', [
            'conteudo' => __DIR__ . '/../Views/estados_civis/index.php',
            'dados'    => $dados
        ]);
    }

    public function cadastrar()
    {
        if ($_SERVER['REQUEST_METHOD'] == 'POST') {
            $formulario = filter_input_array(INPUT_POST, FILTER_SANITIZE_SPECIAL_CHARS);

            $dados = [
                'descricao'  => strtoupper($formulario['descricao'] ?? ''),
                'id_usuario' => $_SESSION['id_usuario'] ?? 1
            ];

            if ($this->estadoCivilModel->armazenar($dados)) {
                Sessao::mensagem('estado_civil', 'Estado civil cadastrado com sucesso!');
                URL::redirecionar('estados_civis');
            } else {
                Sessao::mensagem('estado_civil', 'Erro ao cadastrar estado civil', 'alert alert-danger');
            }
        }

        $this->view('layout', [
            'conteudo' => __DIR__ . '/../Views/estados_civis/cadastrar.php'
        ]);
    }

    public function editar($id)
    {
        if ($_SERVER['REQUEST_METHOD'] == 'POST') {
            $formulario = filter_input_array(INPUT_POST, FILTER_SANITIZE_SPECIAL_CHARS);

            $dados = [
                'id_estado_civil' => $id,
                'descricao'       => strtoupper($formulario['descricao'] ?? '')
            ];

            if ($this->estadoCivilModel->atualizar($dados)) {
                Sessao::mensagem('estado_civil', 'Estado civil atualizado com sucesso!');
                URL::redirecionar('estados_civis');
            } else {
                Sessao::mensagem('estado_civil', 'Erro ao atualizar estado civil', 'alert alert-danger');
            }
        }

        $estado_civil = $this->estadoCivilModel->lerEstadoCivilPorId($id);

        $dados = [
            'estado_civil' => $estado_civil
        ];

        $this->view('layout', [
            'conteudo' => __DIR__ . '/../Views/estados_civis/editar.php',
            'dados'    => $dados
        ]);
    }

    public function visualizar($id)
    {
        $dados = [
            'estado_civil' => $this->estadoCivilModel->lerEstadoCivilPorId($id)
        ];
        $this->view('layout', [
            'conteudo' => __DIR__ . '/../Views/estados_civis/visualizar.php',
            'dados'    => $dados
        ]);
    }

    public function excluir($id)
    {
        if ($this->estadoCivilModel->remover($id)) {
            Sessao::mensagem('estado_civil', 'Estado civil removido com sucesso!');
        } else {
            Sessao::mensagem('estado_civil', 'Erro ao remover estado civil', 'alert alert-danger');
        }
        URL::redirecionar('estados_civis');
    }
}
